#include "AttackPlanner.h"

AttackPlanner::AttackPlanner(){
	//init();
}

AttackPlanner::~AttackPlanner(){

}

void AttackPlanner::init(){
	defenseUnits.clear();
	discoverdEnemyUnits.clear();
	attackUnits.clear();
	destroyNum = 0;
	attackStartFlg = false;
	myBaseLocation = InformationManager::Instance().getMainBaseLocation(BWAPI::Broodwar->self());
	calculateWaitingPosition();
}

AttackPlanner& AttackPlanner::Instance(){
	static AttackPlanner instance;
	return instance;
}

/*
void AttackPlanner::setAttackStartFlg(bool flg){
attackStartFlg = flg;
}

bool AttackPlanner::getAttacStartFlg(){
return attackStartFlg;
}
*/

void AttackPlanner::calculateWaitingPosition(){
	//JE^[ɎQ郆jbg̑ҋ@ꏊiwaitPositionjZo
	BWAPI::Position myBasePosition = myBaseLocation->getPosition();
	BWAPI::Position nearestChokePosition = BWTA::getNearestChokepoint(myBasePosition)->getCenter();

	double vecX,vecY;
	vecX = nearestChokePosition.x() - myBasePosition.x();
	vecY = nearestChokePosition.y() - myBasePosition.y();
	double x,y;
	x = myBasePosition.x() + vecX * 0.70;
	y = myBasePosition.y() + vecY * 0.40;
	waitPosition = BWAPI::Position(int(x),int(y));
}

bool AttackPlanner::isExsitEnemyInSight(){
	discoverdEnemyUnits.clear();
	BOOST_FOREACH(BWAPI::Unit* unit, defenseUnits){
		//G𔭌discoverdEnemyUnitsɉ
		UnitGroup enemyUnits = SelectAllEnemy().inRadius(double( unit->getType().sightRange() ), unit->getPosition());
		if( !enemyUnits.empty() ){
			BOOST_FOREACH(BWAPI::Unit* eunit, enemyUnits){
				if(discoverdEnemyUnits.find(eunit) == discoverdEnemyUnits.end()){
					discoverdEnemyUnits.insert(eunit);
				}
			}
		}
	}
	return discoverdEnemyUnits.empty() ? false : true;
}

void AttackPlanner::update(){

	bool isEnemyExsit = isExsitEnemyInSight();

	//JE^[Jn
	if( attackStartFlg ){
		attackUnits += defenseUnits;
		attackStartFlg = false;//tOZbg
		destroyNum = 0;
		defenseUnits.clear();
		discoverdEnemyUnits.clear();

		//}ĂjbgGx[X֍sR
		BOOST_FOREACH(BWAPI::Unit* unit, attackUnits){
			if(!unit->isAttacking()){
				std::set<BWTA::Region*> enemyRegions = InformationManager::Instance().getOccupiedRegions(BWAPI::Broodwar->enemy());
				if(enemyRegions.empty()) continue;
				std::set<BWTA::BaseLocation*> enemyLocations = (*enemyRegions.begin())->getBaseLocations();
				unit->move( (*enemyLocations.begin())->getPosition() );
			}
		}
	}
	//------------------------------------------------JE^[U--------------------------------------------------//
	if( !attackUnits.empty() ){
		BOOST_FOREACH(BWAPI::Unit* unit, attackUnits){
			UnitGroup enemyUnits = myAttackManager.getEnemiesInSight(unit);
			if(!enemyUnits.empty()){
				if( unit->getLastCommand().getType() != BWAPI::UnitCommandTypes::Attack_Unit ){
					unit->attack(myAttackManager.getLowestHPEnemy(enemyUnits));//͈͓ōŏHP̓GɍU
				}
			}
			if(unit->isIdle()){
				std::set<BWTA::Region*> enemyRegions = InformationManager::Instance().getOccupiedRegions(BWAPI::Broodwar->enemy());
				if(enemyRegions.empty()) continue;
				std::set<BWTA::BaseLocation*> enemyLocations = (*enemyRegions.begin())->getBaseLocations();
				unit->move( (*enemyLocations.begin())->getPosition() );
			}
		}
	}



	//------------------------------------------------JE^[JnO--------------------------------------------------//

	//ҋ@
	if( !isEnemyExsit && !attackStartFlg ){
		BWAPI::Broodwar->drawTextScreen(10,0,"Defense mode");
		BOOST_FOREACH(BWAPI::Unit* unit, defenseUnits){
			if( unit->getDistance(waitPosition) < defenseUnits.size() * 3 ){
				unit->stop();//xҋ@ꏊɋ߂Â瓞Ƃ݂ȂXgbv
			}
			else if(!unit->isMoving())
				unit->move(waitPosition);//ҋ@ꏊɈړ
		}
		//hԐGSł => x̐͂΍UJntOtrue
		if(defenseUnits.size() > destroyNum / 3 && destroyNum > 6){
			attackStartFlg = true;
		}
	}
	//}
	else if( isEnemyExsit && !attackStartFlg ){
		BWAPI::Broodwar->drawTextScreen(10,0,"Intercept mode Enemy=%d",discoverdEnemyUnits.size());
		BOOST_FOREACH(BWAPI::Unit* unit, defenseUnits){
			UnitGroup enemyUnits = discoverdEnemyUnits;
			if(!enemyUnits.empty()){
				if( unit->getLastCommand().getType() != BWAPI::UnitCommandTypes::Attack_Unit){
					BWAPI::Unit* lowestHP = myAttackManager.getLowestHPEnemy(enemyUnits);
					unit->attack(lowestHP);//͈͓ōŏHP̓GɍU
				}
			}
		}
	}
	else if( BWAPI::Broodwar->self()->supplyTotal() >190 ){
		attackStartFlg = true;
	}
}

void AttackPlanner::onUnitCreate(BWAPI::Unit* unit){
	BWAPI::Broodwar->drawTextScreen(10,100,"unit create!");
	//ݑҋ@n_ɂ퓬jbĝ݃JE^[ɎQ
	/*if(!unit->getType().isWorker()){
	defenseUnits.insert(unit);
	BWAPI::Broodwar->drawTextScreen(100,100,"belong unit");
	}*/
}

void AttackPlanner::onUnitDestroy(BWAPI::Unit* unit){
	if(defenseUnits.find(unit) != defenseUnits.end()){
		defenseUnits.erase(unit);
	}
	if(discoverdEnemyUnits.find(unit) != discoverdEnemyUnits.end() ){
		discoverdEnemyUnits.erase(unit);
		destroyNum++;
	}
	if(attackUnits.find(unit) != attackUnits.end()){
		attackUnits.erase(unit);
	}
}

void AttackPlanner::onUnitShow(BWAPI::Unit* unit){
	//퓬pjbgȂJE^[ɎQ
	if( !unit->getType().isWorker() && !unit->getType().isBuilding() && unit->getPlayer() == BWAPI::Broodwar->self()){
		if(defenseUnits.find(unit) == defenseUnits.end()){
			defenseUnits.insert(unit);
		}
	}
}