#pragma once
#include <BWAPI.h>
#include <BWTA.h>
#include <Arbitrator.h>
#include "../UAlbertaBot/Source/InformationManager.h"
#include "../UAlbertaBot/Source/base/BuildingManager.h"
#include "../UAlbertaBot/Source/base/ProductionManager.h"
#include "../UAlbertaBot/Source/base/WorkerManager.h"
#include "../UAlbertaBot/Source/MapGrid.h"
#include "../UAlbertaBot/Source/ScoutManager.h"
#include "../UAlbertaBot/Source/GameCommander.h"
#include <UnitGroupManager.h>
#include <EnhancedUI.h>
#include <Display.h>
#include <boost/foreach.hpp>
#include <AttackPlanner.h>
#include <DebugManager.h>
class InformationManager;
class BasicAIModule : public BWAPI::AIModule
{
private:
	TimerManager timerManager;
	ScoutManager scoutManager;

	std::set<BWAPI::Unit *> scoutUnits;
	
	std::set<BWAPI::Unit *>	validUnits;
	std::set<BWAPI::Unit *> assignedUnits;

	BWAPI::Unit * currentScout;
	int numWorkerScouts;

	const bool isAssigned(BWAPI::Unit * unit) const;
public:
  virtual void onStart();
  virtual void onEnd(bool isWinner);
  virtual void onFrame();
  virtual void onUnitShow(BWAPI::Unit* unit);
  virtual void onUnitHide(BWAPI::Unit* unit);
  virtual void onUnitCreate(BWAPI::Unit* unit);
  virtual void onUnitDiscover(BWAPI::Unit* unit);
  virtual void onUnitEvade(BWAPI::Unit* unit);
  virtual void onUnitMorph(BWAPI::Unit* unit);
  virtual void onUnitRenegade(BWAPI::Unit* unit);
  virtual void onUnitDestroy(BWAPI::Unit* unit);
  virtual void onSendText(std::string text);
  ~BasicAIModule(); //not part of BWAPI::AIModule
  void showStats(); //not part of BWAPI::AIModule
  void showPlayers();
  void showForces();

  void setScoutUnits();
  void setNumWorkerScouts(int);
  void setCurrentScout(BWAPI::Unit *);
  void setValidUnits();

  BWAPI::Unit * getFirstSupplyProvider();
  BWAPI::Unit * getClosestUnitToTarget(BWAPI::UnitType type, BWAPI::Position target);
  BWAPI::Unit * getClosestWorkerToTarget(BWAPI::Position target);

  bool analyzed;
  std::map<BWAPI::Unit*,BWAPI::UnitType> buildings;
  Arbitrator::Arbitrator<BWAPI::Unit*,double> arbitrator;
  UnitGroupManager* unitGroupManager;
  EnhancedUI* enhancedUI;
  Display* display;
  DebugManager* debugmanager;
  bool showManagerAssignments;
};