#include "UnitTypeManager.h"
using namespace BWAPI;


UnitTypeManager::UnitTypeManager(Race race, OPTION opt){
	int i = 0;

	if( race == Races::Terran ){
		if( opt == ALL || opt == GROUND ){
			//Terran Ground Units (10 units)
			unitType[i++] = UnitTypes::Terran_Firebat;
			unitType[i++] = UnitTypes::Terran_Ghost;
			unitType[i++] = UnitTypes::Terran_Goliath;
			unitType[i++] = UnitTypes::Terran_Marine;
			unitType[i++] = UnitTypes::Terran_Medic;
			unitType[i++] = UnitTypes::Terran_SCV;
			unitType[i++] = UnitTypes::Terran_Siege_Tank_Siege_Mode;
			unitType[i++] = UnitTypes::Terran_Siege_Tank_Tank_Mode;
			unitType[i++] = UnitTypes::Terran_Vulture;
			unitType[i++] = UnitTypes::Terran_Vulture_Spider_Mine;
		}

		if( opt == ALL || opt == AIR ){
			//Terran Air Units (6 units)
			unitType[i++] = UnitTypes::Terran_Battlecruiser;
			unitType[i++] = UnitTypes::Terran_Dropship;
			unitType[i++] = UnitTypes::Terran_Nuclear_Missile;
			unitType[i++] = UnitTypes::Terran_Science_Vessel;
			unitType[i++] = UnitTypes::Terran_Valkyrie;
			unitType[i++] = UnitTypes::Terran_Wraith;
		}

		//Terran Heros
		if( opt == ALL || opt == HERO ){
			unitType[i++] = UnitTypes::Hero_Alan_Schezar;
			unitType[i++] = UnitTypes::Hero_Alexei_Stukov;
			unitType[i++] = UnitTypes::Hero_Arcturus_Mengsk;
			unitType[i++] = UnitTypes::Hero_Edmund_Duke_Siege_Mode;
			unitType[i++] = UnitTypes::Hero_Edmund_Duke_Tank_Mode;
			unitType[i++] = UnitTypes::Hero_Gerard_DuGalle;
			unitType[i++] = UnitTypes::Hero_Gui_Montag;
			unitType[i++] = UnitTypes::Hero_Hyperion;
		}
		if( opt == ALL || opt == BUILDING ){
			//Terran Buildings
			unitType[i++] = UnitTypes::Terran_Academy;
			unitType[i++] = UnitTypes::Terran_Armory;
			unitType[i++] = UnitTypes::Terran_Barracks;
			unitType[i++] = UnitTypes::Terran_Bunker;
			unitType[i++] = UnitTypes::Terran_Command_Center;
			unitType[i++] = UnitTypes::Terran_Engineering_Bay;
			unitType[i++] = UnitTypes::Terran_Factory;
			unitType[i++] = UnitTypes::Terran_Missile_Turret;
			unitType[i++] = UnitTypes::Terran_Refinery;
			unitType[i++] = UnitTypes::Terran_Science_Facility;
			unitType[i++] = UnitTypes::Terran_Starport;
			unitType[i++] = UnitTypes::Terran_Supply_Depot;
		}
		if( opt == ALL || opt == SPBUILDING ){
			//Terran Supecial Buildings
			unitType[i++] = UnitTypes::Special_Crashed_Norad_II;
			unitType[i++] = UnitTypes::Special_Ion_Cannon;
			unitType[i++] = UnitTypes::Special_Power_Generator;
			unitType[i++] = UnitTypes::Special_Psi_Disrupter;
		}
	}

	else if( race == Races::Protoss ){
		//Protoss Ground Units
		if( opt == ALL || opt == GROUND ){
			unitType[i++] = UnitTypes::Protoss_Archon;
			unitType[i++] = UnitTypes::Protoss_Dark_Archon;
			unitType[i++] = UnitTypes::Protoss_Dark_Templar;
			unitType[i++] = UnitTypes::Protoss_Dragoon;
			unitType[i++] = UnitTypes::Protoss_High_Templar;
			unitType[i++] = UnitTypes::Protoss_Probe;
			unitType[i++] = UnitTypes::Protoss_Reaver;
			unitType[i++] = UnitTypes::Protoss_Scarab;
			unitType[i++] = UnitTypes::Protoss_Zealot;
		}
		if( opt == ALL || opt == AIR ){
			//Protoss Air Units
			unitType[i++] = UnitTypes::Protoss_Arbiter;
			unitType[i++] = UnitTypes::Protoss_Carrier;
			unitType[i++] = UnitTypes::Protoss_Corsair;
			unitType[i++] = UnitTypes::Protoss_Interceptor;
			unitType[i++] = UnitTypes::Protoss_Observer;
			unitType[i++] = UnitTypes::Protoss_Scout;
			unitType[i++] = UnitTypes::Protoss_Shuttle;
		}
		if( opt == ALL || opt == HERO ){
			//Protoss Heroes
			unitType[i++] = UnitTypes::Hero_Aldaris;
			unitType[i++] = UnitTypes::Hero_Artanis;
			unitType[i++] = UnitTypes::Hero_Danimoth;
			unitType[i++] = UnitTypes::Hero_Dark_Templar;
			unitType[i++] = UnitTypes::Hero_Fenix_Dragoon;
			unitType[i++] = UnitTypes::Hero_Fenix_Zealot;
			unitType[i++] = UnitTypes::Hero_Mojo;
			unitType[i++] = UnitTypes::Hero_Raszagal;
			unitType[i++] = UnitTypes::Hero_Tassadar;
			unitType[i++] = UnitTypes::Hero_Tassadar_Zeratul_Archon;
			unitType[i++] = UnitTypes::Hero_Warbringer;
			unitType[i++] = UnitTypes::Hero_Zeratul;
		}
		if( opt == ALL || opt == BUILDING ){
			//Protoss Buildings
			unitType[i++] = UnitTypes::Protoss_Arbiter_Tribunal;
			unitType[i++] = UnitTypes::Protoss_Assimilator;
			unitType[i++] = UnitTypes::Protoss_Citadel_of_Adun;
			unitType[i++] = UnitTypes::Protoss_Cybernetics_Core;
			unitType[i++] = UnitTypes::Protoss_Fleet_Beacon;
			unitType[i++] = UnitTypes::Protoss_Forge;
			unitType[i++] = UnitTypes::Protoss_Gateway;
			unitType[i++] = UnitTypes::Protoss_Nexus;
			unitType[i++] = UnitTypes::Protoss_Observatory;
			unitType[i++] = UnitTypes::Protoss_Photon_Cannon;
			unitType[i++] = UnitTypes::Protoss_Pylon;
			unitType[i++] = UnitTypes::Protoss_Robotics_Facility;
			unitType[i++] = UnitTypes::Protoss_Robotics_Support_Bay;
			unitType[i++] = UnitTypes::Protoss_Shield_Battery;
			unitType[i++] = UnitTypes::Protoss_Stargate;
			unitType[i++] = UnitTypes::Protoss_Templar_Archives;
		}
		if( opt == ALL || opt == SPBUILDING ){
			//Protoss Special Buildings
			unitType[i++] = UnitTypes::Special_Khaydarin_Crystal_Form;
			unitType[i++] = UnitTypes::Special_Protoss_Temple;
			unitType[i++] = UnitTypes::Special_Stasis_Cell_Prison;
			unitType[i++] = UnitTypes::Special_Warp_Gate;
			unitType[i++] = UnitTypes::Special_XelNaga_Temple;
		}
	}
	else if( race == Races::Zerg ){
		if( opt == ALL || opt == GROUND ){
			//Zerg Ground Units
			unitType[i++] = UnitTypes::Zerg_Broodling;
			unitType[i++] = UnitTypes::Zerg_Defiler;
			unitType[i++] = UnitTypes::Zerg_Drone;
			unitType[i++] = UnitTypes::Zerg_Egg;
			unitType[i++] = UnitTypes::Zerg_Hydralisk;
			unitType[i++] = UnitTypes::Zerg_Infested_Terran;
			unitType[i++] = UnitTypes::Zerg_Larva;
			unitType[i++] = UnitTypes::Zerg_Lurker;
			unitType[i++] = UnitTypes::Zerg_Lurker_Egg;
			unitType[i++] = UnitTypes::Zerg_Ultralisk;
			unitType[i++] = UnitTypes::Zerg_Zergling;
		}
		if( opt == ALL || opt == AIR ){

			//Zerg Air Units
			unitType[i++] = UnitTypes::Zerg_Cocoon;
			unitType[i++] = UnitTypes::Zerg_Devourer;
			unitType[i++] = UnitTypes::Zerg_Guardian;
			unitType[i++] = UnitTypes::Zerg_Mutalisk;
			unitType[i++] = UnitTypes::Zerg_Overlord;
			unitType[i++] = UnitTypes::Zerg_Queen;
			unitType[i++] = UnitTypes::Zerg_Scourge;
		}
		if( opt == ALL || opt == HERO ){
			//Zerg Heroes
			unitType[i++] = UnitTypes::Hero_Devouring_One;
			unitType[i++] = UnitTypes::Hero_Hunter_Killer;
			unitType[i++] = UnitTypes::Hero_Infested_Duran;
			unitType[i++] = UnitTypes::Hero_Infested_Kerrigan;
			unitType[i++] = UnitTypes::Hero_Kukulza_Guardian;
			unitType[i++] = UnitTypes::Hero_Kukulza_Mutalisk;
			unitType[i++] = UnitTypes::Hero_Matriarch;
			unitType[i++] = UnitTypes::Hero_Torrasque;
			unitType[i++] = UnitTypes::Hero_Unclean_One;
			unitType[i++] = UnitTypes::Hero_Yggdrasill;
		}
		if( opt == ALL || opt == BUILDING ){
			//Zerg Buildings
			unitType[i++] = UnitTypes::Zerg_Creep_Colony;
			unitType[i++] = UnitTypes::Zerg_Defiler_Mound;
			unitType[i++] = UnitTypes::Zerg_Evolution_Chamber;
			unitType[i++] = UnitTypes::Zerg_Extractor;
			unitType[i++] = UnitTypes::Zerg_Greater_Spire;
			unitType[i++] = UnitTypes::Zerg_Hatchery;
			unitType[i++] = UnitTypes::Zerg_Hive;
			unitType[i++] = UnitTypes::Zerg_Hydralisk_Den;
			unitType[i++] = UnitTypes::Zerg_Infested_Command_Center;
			unitType[i++] = UnitTypes::Zerg_Lair;
			unitType[i++] = UnitTypes::Zerg_Nydus_Canal;
			unitType[i++] = UnitTypes::Zerg_Queens_Nest;
			unitType[i++] = UnitTypes::Zerg_Spawning_Pool;
			unitType[i++] = UnitTypes::Zerg_Spire;
			unitType[i++] = UnitTypes::Zerg_Spore_Colony;
			unitType[i++] = UnitTypes::Zerg_Sunken_Colony;
			unitType[i++] = UnitTypes::Zerg_Ultralisk_Cavern;
		}
		if( opt == ALL || opt == SPBUILDING ){
			//Zerg Special Buildings
			unitType[i++] = UnitTypes::Special_Cerebrate;
			unitType[i++] = UnitTypes::Special_Cerebrate_Daggoth;
			unitType[i++] = UnitTypes::Special_Mature_Chrysalis;
			unitType[i++] = UnitTypes::Special_Overmind;
			unitType[i++] = UnitTypes::Special_Overmind_Cocoon;
			unitType[i++] = UnitTypes::Special_Overmind_With_Shell;
		}
	}
	else if( race == Races::Other ){
		//Critters
		unitType[i++] = UnitTypes::Critter_Bengalaas;
		unitType[i++] = UnitTypes::Critter_Kakaru;
		unitType[i++] = UnitTypes::Critter_Ragnasaur;
		unitType[i++] = UnitTypes::Critter_Rhynadon;
		unitType[i++] = UnitTypes::Critter_Scantid;
		unitType[i++] = UnitTypes::Critter_Ursadon;

		//Resources
		unitType[i++] = UnitTypes::Resource_Mineral_Field;
		unitType[i++] = UnitTypes::Resource_Mineral_Field_Type_2;
		unitType[i++] = UnitTypes::Resource_Mineral_Field_Type_3;
		unitType[i++] = UnitTypes::Resource_Vespene_Geyser;

		//Spells
		unitType[i++] = UnitTypes::Spell_Dark_Swarm;
		unitType[i++] = UnitTypes::Spell_Disruption_Web;
		unitType[i++] = UnitTypes::Spell_Scanner_Sweep;

		//Beacons
	}
}

UnitType UnitTypeManager::getUnitType(int key){
	return this->unitType[key];
}
int UnitTypeManager::getKey(BWAPI::UnitType type){
	return this->unitType[type];
}
std::map<int,BWAPI::UnitType> UnitTypeManager::getUnitTypes(){
	return unitType;
}
